Program Learn;

Uses Crt,Dos,Time,INI,TypeText,ProtMenu,  HexWrite;

Const
  JoyPort          = $201;
  MaxChannelLength = 256;
  _32BIT_OPERAND   = $66;
  Samples          = 50;
{  ConfigFile       = 'LEARN.INI';}
  ConfigFile       = 'PCAE.INI';
  PopupTitleFore   = Red;

Type
  TInfoType = (itButton,itHat,itThrottle,itTwist,itAxis,itAnalog);
  TDigitalPacket = Object
    Bits: Array[0..MaxChannelLength - 1] Of Byte;
    Procedure Clear;
    Procedure _And(Var Source: TDigitalPacket);
    Procedure _Or(Var Source: TDigitalPacket);
    Procedure _Xor(Var Source: TDigitalPacket);
    Procedure _Not;
    Procedure Copy(Var Source: TDigitalPacket);
    Function  AsString: String;
    Procedure GetDef(Ch: Char; Var Source: TDigitalPacket);
    Procedure SetDef(Ch: Char; Var Source: TDigitalPacket);
    Procedure SetAllDef(Ch: Char);
    Function  Count: Integer;
    Function  Equal(Var Source: TDigitalPacket): Boolean;
  End;
  TXYPoint = Record
    X,Y: Integer;
  End;

Var
  MaxJoyCount    : LongInt;
  Packet         : TDigitalPacket;
  PacketDef      : TDigitalPacket;
  PacketNum      : TDigitalPacket;
  OldPacket      : TDigitalPacket;
  WorkPacket     : TDigitalPacket;
  WorkPacket1    : TDigitalPacket;
  WorkPacket2    : TDigitalPacket;
  WorkPacket3    : TDigitalPacket;
  WorkPacket4    : TDigitalPacket;
  DiffPacket     : TDigitalPacket;
  AnalogPacket   : TDigitalPacket;
  ThrottlePacket : TDigitalPacket;
  BtnPacket      : TDigitalPacket;
  HatPacket      : TDigitalPacket;
  AxisPacket     : TDigitalPacket;
  OnePacket      : TDigitalPacket;
  ZeroPacket     : TDigitalPacket;
  PacketFlp      : TDigitalPacket;
  PacketBit      : TDigitalPacket;
  DiffCount      : Array[0..MaxChannelLength - 1] Of LongInt;
  PacketSize     : Integer;
  _Win           : PWindow;
  F              : Text;
  NumAxes        : Integer;
  NumThrottles   : Integer;
  St             : String;
  I,J            : Integer;
  MasterCount    : LongInt;
  OddCount       : LongInt;
  HasAnalog      : Boolean;
  HasThrottle    : Boolean;

Function IntToStr(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  IntToStr := St;
End; { IntToStr }

Function Trim(St: String): String;
Begin
  While (St <> '') And (St[1]          = ' ') Do St := Copy(St,2,Length(St) - 1);
  While (St <> '') And (St[Length(St)] = ' ') Do St := Copy(St,1,Length(St) - 1);
  Trim := St;
End; { Trim }

Function ToChar(I: Integer): Char;
Var Ch: Char;
Begin
  Case I Of
    0..9: Ch := Chr(I + Ord('0'));
  10..36: Ch := Chr(I + Ord('A') - 10);
  Else
    Ch := '0';
  End; { Case }
  ToChar := Ch;
End; { ToChar }

Procedure StayPopup(TitleTop,TitleBot,St: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);
  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 2,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2,Screen.TextAttr,St);
End; { StayPopup }

Procedure StayPopup4(TitleTop,TitleBot,St1,St2,St3,St4: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St1);
  If Length(St2)      > I Then I := Length(St2);
  If Length(St3)      > I Then I := Length(St3);
  If Length(St4)      > I Then I := Length(St4);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);

  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 3,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 1,Screen.TextAttr,St1);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2,Screen.TextAttr,St2);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3,Screen.TextAttr,St3);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 4,Screen.TextAttr,St4);
End; { StayPopup4 }

Procedure StayPopup12(TitleTop,TitleBot,
                       St1,St2,St3,St4,St5,St6,
                       St7,St8,St9,St10,St11,St12: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St1);
  If Length(St2)      > I Then I := Length(St2);
  If Length(St3)      > I Then I := Length(St3);
  If Length(St4)      > I Then I := Length(St4);
  If Length(St5)      > I Then I := Length(St5);
  If Length(St6)      > I Then I := Length(St6);
  If Length(St7)      > I Then I := Length(St7);
  If Length(St8)      > I Then I := Length(St8);
  If Length(St9)      > I Then I := Length(St9);
  If Length(St10)     > I Then I := Length(St10);
  If Length(St11)     > I Then I := Length(St11);
  If Length(St12)     > I Then I := Length(St12);
  If Length(TitleTop) > I Then I := Length(TitleTop);
  If Length(TitleBot) > I Then I := Length(TitleBot);
  _Win := New(PWindow,InitWH(I + 4,14,
            Black,LightGray,Black,LightGray,PopupTitleFore,LightGray,
            DoubleBorder,TitleTop,TitleBot,True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 1, Screen.TextAttr,St1);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2, Screen.TextAttr,St2);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3, Screen.TextAttr,St3);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 4, Screen.TextAttr,St4);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 5, Screen.TextAttr,St5);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 6, Screen.TextAttr,St6);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 7, Screen.TextAttr,St7);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 8, Screen.TextAttr,St8);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 9, Screen.TextAttr,St9);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 10,Screen.TextAttr,St10);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 11,Screen.TextAttr,St11);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 12,Screen.TextAttr,St12);
End; { StayPopup12 }

Procedure TDigitalPacket.Clear;
Begin
  FillChar(Bits,SizeOf(Bits),#0);
End; { TDigitalPacket.Clear }

Procedure TDigitalPacket._And(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] And Source.Bits[I];
End; { TDigitalPacket._And }

Procedure TDigitalPacket._Or(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Or Source.Bits[I];
End; { TDigitalPacket._Or }

Procedure TDigitalPacket._Xor(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Xor Source.Bits[I];
End; { TDigitalPacket._Xor }

Procedure TDigitalPacket._Not;
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Bits[I] Xor 1;
End; { TDigitalPacket._Not }

Procedure TDigitalPacket.Copy(Var Source: TDigitalPacket);
Var I: Integer;
Begin
  Move(Source.Bits,Bits,SizeOf(Bits));
End; { TDigitalPacket.Copy }

Function TDigitalPacket.AsString: String;
Var
  St : String;
  I  : Integer;

Begin
  St := '';
  For I := 0 To PacketSize - 1 Do
  Begin
    Case Bits[I] Of
      0: St := St + '0';
      1: St := St + '1';
      32..255: St := St + Chr(Bits[I]);
    End; { Case }
  End; { For I }
  AsString := Trim(St);
End; { TDigitalPacket.AsString }

Procedure TDigitalPacket.GetDef(Ch: Char; Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do
   If Chr(Source.Bits[I]) = Ch Then Bits[I] := 1 Else Bits[I] := 0;
End; { TDigitalPacket.GetDef }

Procedure TDigitalPacket.SetDef(Ch: Char; Var Source: TDigitalPacket);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do
   If Source.Bits[I] <> 0 Then Bits[I] := Ord(Ch);
End; { TDigitalPacket.SetDef }

Procedure TDigitalPacket.SetAllDef(Ch: Char);
Var I: Integer;
Begin
  For I := 0 To PacketSize - 1 Do Bits[I] := Ord(Ch);
End; { TDigitalPacket.SetAllDef }

Function TDigitalPacket.Count: Integer;
Var I,J: Integer;
Begin
  J := 0;
  For I := 0 To PacketSize - 1 Do If Bits[I] <> 0 Then Inc(J);
  Count := J;
End; { TDigitalPacket.Count }

Function TDigitalPacket.Equal(Var Source: TDigitalPacket): Boolean;
Var
  I : Integer;
  B : Boolean;

Begin
  B := True;
  I := 0;
  While (I < PacketSize) And B Do
  Begin
    If Bits[I] <> Source.Bits[I] Then B := False;
    Inc(I);
  End; { While }
  Equal := B;
End; { TDigitalPacket.Equal }

Procedure GetMaxJoyCount;
Const
  WaitTime = 300;  { 300 ms }
  ReadTime = 6;    { 6 ms   }

Var
  T1,T2     : LongInt; { Millisecond timers }
  Count     : LongInt; { Iteration count    }
  Both      : LongInt; { Iteration count    }
  ClockOnly : LongInt; { Time in ms         }
  JoyTime   : LongInt; { Time in ms         }

  Function RoundUp(E: Extended): LongInt;
  Begin
    If E < 0 Then
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) - 1 Else RoundUp := Trunc(E);
    End
    Else
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) + 1 Else RoundUp := Trunc(E);
    End;
  End; { RoundUp }

Label TimerLoop;
Begin
  MaxJoyCount := 0;

  { Find out how long it takes to read both the clock and the joystick }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;

    { Reset the joystick port }

    Port[JoyPort] := 0;

    { Perform the loop }

    Asm
      DB     _32BIT_OPERAND  { Reset the counter }
      SUB    BX,BX
TimerLoop:
      IN     AL,DX           { Read and dummy test }
      TEST   AL,1            { Player 1 X coordinate }
      JZ     @L4
      DB     _32BIT_OPERAND  { Dummy increment }
      INC    AX
    @L4:
      DB     _32BIT_OPERAND  { The real increment }
      INC    BX

      DB     _32BIT_OPERAND  { Save registers }
      PUSH   BX
      PUSH   DX
    End; { Asm }
    T2 := Clock;
    Asm
      POP    DX              { Restore registers }
      DB     _32BIT_OPERAND
      POP    BX

      DB     _32BIT_OPERAND  { Check elapsed time }
      MOV    AX,WORD PTR T2
      DB     _32BIT_OPERAND
      SUB    AX,WORD PTR T1
      DB     _32BIT_OPERAND
      CMP    AX,WaitTime
      DW     0
      JB     TimerLoop
      DB     _32BIT_OPERAND
      MOV    WORD PTR Count,BX
    End; { Asm }
  Until T2 >= T1 + WaitTime;
  Both := Count;

  { Now find out how long it takes to do everything we did above except  }
  { read the joystick port                                               }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;
    While Count > 0 Do
    Begin

      { Include what we did above }

      Asm
        DB     _32BIT_OPERAND  { Save registers }
        PUSH   BX
        PUSH   DX
      End; { Asm }

      T2 := Clock;

      Asm
        POP    DX              { Restore registers }
        DB     _32BIT_OPERAND
        POP    BX
        DB     _32BIT_OPERAND  { Check elapsed time }
        MOV    AX,WORD PTR T2
        DB     _32BIT_OPERAND
        SUB    AX,WORD PTR T1
        DB     _32BIT_OPERAND
        CMP    AX,WaitTime
        DW     0
        JB     @L1
        DB     _32BIT_OPERAND  { Do anythng here (likely won't be executed) }
        MOV    AX,WORD PTR T2
@L1:
      End; { Asm }

      Dec(Count);
    End; { While }
  Until T2 >= T1;
  ClockOnly := T2 - T1;

  { The time we spent actually reading the port is WaitTime - ClockOnly. }
  { Calculate the number of joystick read iterations that we can perform }
  { in 3 ms. If WaitTime - ClockOnly is zero, force it to one, but this  }
  { really should never happen.                                          }

  JoyTime := WaitTime - ClockOnly;
  If JoyTime <= 0 Then JoyTime := 1;

  MaxJoyCount := RoundUp(ReadTime * (Both / JoyTime));
End; { GetMaxJoyCount }

Function ReadPacket(Var Packet: TDigitalPacket): Integer;
Var
  Channel      : TDigitalPacket;
  Count        : LongInt;
  ChLen        : Word;
  I,J          : Integer;
  NewPacketLen : Integer;
  Size         : Integer;
  Cycle        : LongInt;
  CycleTime    : LongInt;
  CycleStart   : LongInt;
  LoopTime     : LongInt;
  CycleSet     : Boolean;
  CycleBegin   : Boolean;

  Procedure Expand1;
  Var I: Integer;
  Begin
    For I := 0 To ChLen - 1 Do Channel.Bits[I] := (Channel.Bits[I] And $20) Shr 5;
    NewPacketLen := ChLen;
  End; { Expand1 }

  Procedure Expand3;
  Var I: Integer;
  Begin
    For I := ChLen - 1 DownTo 0 Do
    Begin
      If (I * 3) + 2 < SizeOf(Channel) Then
      Begin

        { Flip bits }

        If (Channel.Bits[I] And $80) = 0
         Then Channel.Bits[I * 3 + 2] := 0
         Else Channel.Bits[I * 3 + 2] := 1;
        If (Channel.Bits[I] And $40) = 0
         Then Channel.Bits[I * 3 + 1] := 0
         Else Channel.Bits[I * 3 + 1] := 1;
        If (Channel.Bits[I] And $20) = 0
         Then Channel.Bits[I * 3] := 0
         Else Channel.Bits[I * 3] := 1;
      End;
    End; { For I }
    NewPacketLen := ChLen * 3;
  End; { Expand3 }

  Procedure Expand;
  Var
    I,J,K : Integer;
    Uses3 : Boolean;

  Begin

    { Determine if the packet used only one or all three bits }

    Uses3 := False;
    I     := 1;
    J     := 0;
    K     := 0;
    If ChLen < 8 Then Uses3 := True Else
    Begin
      While (I < ChLen) And Not Uses3 Do
      Begin
        If (Channel.Bits[I] And $80) <> (Channel.Bits[I - 1] And $80) Then K := $FF Else K := 0;
        J := J Xor (Channel.Bits[I] Xor K Xor Channel.Bits[I - 1]);
        If (J And $C0) <> 0
         Then Uses3 := True
         Else Inc(I);
      End; { While }
    End;
    If Uses3 Then Expand3 Else Expand1;
(*
    J := 0;
    For I := 1 To ChLen - 1 Do J := J Or (Channel.Bits[I - 1] Xor Channel.Bits[I]);
    J ;= (J Shr 5) And 6;
    If (J And $C0) <> 0 Then Expand3 Else Expand1;
*)
{    If (J And $70) = 0 Then NewPacketLen := 0;}
  End; { Expand }

  Function _Uses3: Boolean;
  Var
    I,J,K : Integer;
    B     : Boolean;

  Begin

    { Determine if the packet used only one or all three bits }

    B := False;
    I := 1;
    J := 0;
    K := 0;
    If ChLen < 8 Then B := True Else
    Begin
      While (I < ChLen) And Not B Do
      Begin
        If (Channel.Bits[I] And $80) <> (Channel.Bits[I - 1] And $80) Then K := $FF Else K := 0;
        J := J Xor (Channel.Bits[I] Xor K Xor Channel.Bits[I - 1]);
        If (J And $C0) <> 0
         Then B := True
         Else Inc(I);
      End; { While }
    End;
    _Uses3 := B;
  End; { _Uses3 }

Begin
  Channel.Clear;                         { Initialize with zeroes }
  Count      := MaxJoyCount;
  Size       := MaxChannelLength;
  Cycle      := 0;
  CycleTime  := 0;
  CycleSet   := False;
  CycleBegin := False;
  CycleStart := 0;
  LoopTime   := 0;
  Asm
    MOV   DX,JoyPort                     { Reset the joystick port }
    MOV   AL,0FFh
    OUT   DX,AL
    IN    AL,DX                          { Read the initial value }

(*
    TEST  AL,01h                         { Invalid packet? }
    JZ    @GetOut
*)

    MOV   BL,AL                          { Save the initial value }
    DB    _32BIT_OPERAND                 { Set the timeout counter }
    MOV   CX,WORD PTR Count
    SUB   SI,SI                          { Packet pointer }

    { Wait for first falling edge on clock }

@ClockLoop:
    DB    _32BIT_OPERAND                 { Decrement the timeout counter }
    DEC   CX
    JS    @GetOut                        { Exit if timeout }
    IN    AL,DX                          { Read a byte }
    MOV   BH,AL                          { Save it }
    XOR   AL,BL                          { See if anything has changed }
    TEST  AL,10h
    JZ    @ClockLoop
    TEST  BH,10h                         { Check for the falling edge }
    JNZ   @ClockLoop

    { Get data on rising edges }

@PacketLoop:
    DB    _32BIT_OPERAND                 { Decrement the timeout counter }
    DEC   CX
    JS    @GetOut                        { Exit if timeout }
    IN    AL,DX                          { Read a byte }

    MOV   BH,AL                          { Save it }
    XOR   AL,BL                          { See if anything has changed }

    TEST  AL,10h                         { See if the clock bit changed }
    JZ    @NoClockChanged
    TEST  BH,10h                         { Check for the rising edge }
    JNZ   @DataAvailable

@NoClockChanged:
    TEST  BYTE PTR CycleSet,0FFh         { Do we know the cycle time? }
    JZ    @NextByte
    DB    _32BIT_OPERAND                 { Exit if the clock has stopped }
    DEC   WORD PTR Cycle
    JZ    @GetOut
    JMP   @NextByte

@DataAvailable:
    TEST  BYTE PTR CycleBegin,0FFh       { See if we've recorded the }
    JNZ   @FoundBeginning                {  starting time }
    MOV   BYTE PTR CycleBegin,1
    DB    _32BIT_OPERAND
    PUSH  AX
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR LoopTime
    DB    _32BIT_OPERAND
    MOV   WORD PTR CycleStart,AX
    DB    _32BIT_OPERAND
    POP   AX
    JMP   @CycleSet

@FoundBeginning:
    TEST  BYTE PTR CycleSet,0FFh
    JNZ   @CycleSet
    DB    _32BIT_OPERAND                 { Record 4x the cycle time }
    PUSH  AX
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR LoopTime
    DB    _32BIT_OPERAND
    SUB   AX,WORD PTR CycleStart
    DB    _32BIT_OPERAND
    SHL   AX,2
    DB    _32BIT_OPERAND
    MOV   WORD PTR CycleTime,AX
    MOV   BYTE PTR CycleSet,1
    DB    _32BIT_OPERAND
    POP   AX

@CycleSet:
    DB    _32BIT_OPERAND                 { Reset the cycle time counter }
    PUSH  AX
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR CycleTime
    DB    _32BIT_OPERAND
    MOV   WORD PTR Cycle,AX
    DB    _32BIT_OPERAND
    POP   AX

    TEST  BH,1                           { If bit 0 goes low, then we're }
    JNZ   @NotHalf                       {  halfway through the packet   }
    CMP   WORD PTR Size,MaxChannelLength
    JNZ   @NotHalf
    CMP   SI,4                           { Ignore any initial low state }
    JBE   @NotHalf
    MOV   WORD PTR Size,SI
    ADD   WORD PTR Size,4                { Allow some fuzziness }
    SHL   WORD PTR Size,1
@NotHalf:

    { Save the data }

    MOV   BYTE PTR Channel.Bits[SI],BH
    INC   SI
(*
    CMP   SI,MaxChannelLength            { Exit if at maximum size }
    JAE   @GetOut
*)
    CMP   SI,WORD PTR Size               { Exit if we reach the packet size }
    JAE   @GetOut

@NextByte:
    MOV   BL,BH                          { Save the byte that was read }
    DB    _32BIT_OPERAND
    INC   WORD PTR LoopTime
    JMP   @PacketLoop
@GetOut:
    DB    _32BIT_OPERAND                 { Save the final counter }
    MOV   WORD PTR Count,CX
    MOV   WORD PTR ChLen,SI
  End; { Asm }
  Delay(4);     { Need this! }



{
  Assign(F,'SW.LOG');
  ReWrite(F,1);
  BlockWrite(F,Channel,SizeOf(Channel));
  Close(F);
}
{
  Popup('ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(Count));
}
{
  Screen.FastWrite(1,3,7,'ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(MaxJoyCount - Count));
}

{
  Screen.FastWrite(1,3,7,'CS: ' + IntToStr(CycleStart));
  Screen.FastWrite(1,4,7,'CT: ' + IntToStr(CycleTime));
  Screen.FastWrite(1,5,7,'Sz: ' + IntToStr(Size));
}
  { Evaluate the packet }

  If ChLen < MaxChannelLength Then
  Begin
{
    If _Uses3 Then

     For I := 0 To ChLen - 1 Do
      Screen.FastWrite(30 + (I Div 50) * 9,(I Mod 50) + 1,7,BinByte(Channel.Bits[I]))

    Else

     For I := 0 To ChLen - 1 Do
      Screen.FastWrite(20 + (I Div 50) * 9,(I Mod 50) + 1,7,BinByte(Channel.Bits[I]));
}
    Expand;

{    Screen.FastWrite(1,4,7,'NewPacketLen: ' + IntToStr(NewPacketLen));}

    ReadPacket := NewPacketLen;
    Move(Channel.Bits,Packet.Bits,SizeOf(Packet.Bits));
  End
  Else ReadPacket := 0;
End; { ReadPacket }

Procedure GetPacketSize;
Var
  Size   : Array[1..Samples] Of Integer;
  Num    : Array[0..255]     Of Integer;
  I,J    : Integer;
  St,St1 : String;

Begin
  FillChar(Size,SizeOf(Size),#0);
  FillChar(Num,SizeOf(Num),#0);
  I := 1;
  Port[JoyPort] := $FF;  { Reset the port and wait 1 full second to skip }
                         { the ID packet (I don't know how to parse it)  }
  Delay(1000);
  St1 := '';
  While Length(St1) < (Lo(Screen.WindMax) - Lo(Screen.WindMin) - 1) Do St1 := St1 + ' ';
  While (I < Samples) And Not KeyPressed Do
  Begin

    { Display progress bar }

    St := St1;
    J := Round((I / Samples) * Length(St));
    While J > 0 Do
    Begin
      St[J] := '';
      Dec(J);
    End; { While }
    Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3,
     Screen.TextAttr,St);

    { Attempt to read a digital packet }

    J := ReadPacket(Packet);
    Delay(50);
    If J > 0 Then
    Begin
      Size[I] := J;
      Inc(I);
    End;
  End; { While }
  If KeyPressed Then Halt
  Else
  Begin
    For J := 1 To I - 1 Do If Size[J] < 256 Then Inc(Num[Size[J]]);

{
    Screen.Window(1,1,MaxX,MaxY);
    Screen.GotoXY(1,15);
    For I := 0 To 255 Do Screen.Write(IntToStr(Num[I]) + ' ');
}

    PacketSize := 0;
    J          := 0;
    For I := 0 To 255 Do If Num[I] > J Then
    Begin
      PacketSize := I;
      J          := Num[I];
    End;

    { If the controller was in triplet mode, the reported packet size }
    { may be one or two bits too large.  If enough packets were sent  }
    { in single-bit mode, use the smaller packet size instead, since  }
    { we'll have trouble finding the larger packet size if the        }
    { controller goes back to single-bit mode.                        }

    If ((PacketSize Mod 3) = 0) And (PacketSize >= 3) Then
    Begin
      I := PacketSize;
      If Num[PacketSize - 1] >= Round(J * 0.75) Then I := PacketSize - 1;
      If Num[PacketSize - 2] >= Round(J * 0.75) Then I := PacketSize - 2;
      PacketSize := I;
    End;
  End;

{  ReadKey;}

End; { GetPacketSize }

Procedure GatherAll;
Var
  Ch   : Char;
  Size : Integer;
  I    : Integer;

  Procedure HandleTripletMode;
  Begin
    { If the controller is sending three bits at a time, it can send }
    { an extra bit or two under some circumstances compared to when  }
    { the controller is in single-bit mode.                          }

    If ((PacketSize Mod 3) = 1) And (Size = PacketSize + 2) Then Size := PacketSize;
    If ((PacketSize Mod 3) = 2) And (Size = PacketSize + 1) Then Size := PacketSize;
  End; { HandleTripletMode }

Begin
  Repeat
    Size := ReadPacket(Packet);
    HandleTripletMode;
  Until Size = PacketSize;
  DiffPacket.Clear;
  FillChar(DiffCount,SizeOf(DiffCount),#0);
  Repeat
    Size := ReadPacket(Packet);
    HandleTripletMode;

    If Size = PacketSize Then
{    If ReadPacket(Packet) = PacketSize Then}
    Begin
      Screen.FastWrite(1,MaxY,$17,Packet.AsString + '   ');
      WorkPacket.Copy(Packet);
      WorkPacket._Xor(OldPacket);
      DiffPacket._Or(WorkPacket);
      OnePacket._And(Packet);
      ZeroPacket._Or(Packet);
      OldPacket.Copy(Packet);
{      If DiffPacket.Count > 0 Then}
      If WorkPacket.Count > 0 Then
      Begin
        Inc(MasterCount);
        If (Packet.Count And 1) <> 0 Then Inc(OddCount);
      End;
      For I := 0 To 255 Do
       If WorkPacket.Bits[I] <> 0 Then Inc(DiffCount[I]);
{      Screen.FastWrite(1,MaxY - 1,$17,DiffPacket.AsString);}
    End;
  Until KeyPressed;
  While KeyPressed Do Ch := ReadKey;
  If Ch = #27 Then Halt;
End; { GatherAll }

Procedure FindAll;
Var
  I : Integer;
  L : LongInt;

Begin
  StayPopup12(' Establish all controller functions ',' Initial step ',
     '',
     'Slowly do the following:',
     '- Manipulate ALL controls on your controller',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     'When finished press a key (hit Esc to exit)');
  L := MasterCount;
  GatherAll;
  Dispose(_Win,Done);

  { If the controller was in triplet mode, the reported packet size }
  { may be one or two bits too large.  If there are one or two bits }
  { at the end of the packet that never change, reduce the packet   }
  { size, since we'll have trouble finding the larger packet size   }
  { if the controller goes back to single-bit mode.                 }
(*
  Screen.FastWrite(1,14,7,'PacketSize: ' + IntToStr(PacketSize));
  Screen.Window(1,1,MaxX,MaxY);
  Screen.TextColor(LightGray);
  Screen.TextBackGround(Black);
  Screen.GotoXY(1,15);
  For I := 0 To PacketSize - 1 Do Screen.Write(IntToStr(Round(100 * DiffCount[I] / (MasterCount - L))) + ' ');
  ReadKey;
*)
  If ((PacketSize Mod 3) = 0) Then
  Begin
    I := PacketSize;

    { Bit glitches happen; allow a little fuzziness }

    If DiffCount[I - 1] / (MasterCount - L) < 0.03 Then
    Begin
      Dec(I);
      If DiffCount[I - 1] / (MasterCount - L) < 0.03 Then Dec(I);
    End;
    PacketSize := I;
  End;
End; { FindAll }

Procedure FindAllAnalog;
Var Ch: Char;
Begin
  StayPopup4(' Establish all non-button functions ',' Step 1a ',
   'Does your controller support either ANALOG or THROTTLE',
   'movement? (Y/N)',
   '',
   'Hit Esc to exit');
  Repeat
    Ch := UpCase(ReadKey);
  Until Ch In [#27,'N','Y'];
  Dispose(_Win,Done);
  If Ch = #27 Then Halt;
  If Ch = 'Y' Then
  Begin
    StayPopup12(' Establish all non-button functions ',' Step 1b ',
       'DO NOT PRESS ANY JOYSTICK BUTTONS OR MOVE ANY DIGITAL',
       'HATS OR DIGITAL DIRECTIONAL CONTROLS',
       '',
       'Slowly do the following:',
       '- Move ALL ANALOG joysticks to all extremes',
       '- Move all throttles to both extremes',
       '- Twist handle(s) to both extremes, if available',
       '- Press all ANALOG flippers',
       '- Move all ANALOG hats to all extremes',
       '- Tilt entire controller in all directions',
       '',
       'When finished press a key (hit Esc to exit)');
    GatherAll;
    Dispose(_Win,Done);
  End
  Else
  Begin
    DiffPacket.Clear;
    HasAnalog   := False;
    HasThrottle := False;
  End;
End; { FindAllAnalog }

Procedure FindAllDigitalHats;
Var Ch: Char;
Begin
  StayPopup4(' Establish all digital hat functions ',' Step 2a ',
   'Does your controller have a digital hat? (Y/N)',
   '(Do NOT include digital direction controls)',
   '',
   'Hit esc to exit');
  Repeat
    Ch := UpCase(ReadKey);
  Until Ch In [#27,'N','Y'];
  Dispose(_Win,Done);
  If Ch = #27 Then Halt;
  If Ch = 'Y' Then
  Begin
    StayPopup12(' Establish all digital hat functions ',' Step 2b ',
       '',
       'DO NOT PRESS ANY JOYSTICK BUTTONS OR MOVE ANY DIGITAL',
       'DIRECTIONAL CONTROLS',
       '',
       'Slowly do the following:',
       '- Move all DIGITAL hats to all extremes',
       '',
       '',
       '',
       '',
       '',
       'When finished press a key (hit Esc to exit)');
    GatherAll;
    Dispose(_Win,Done);
  End
  Else DiffPacket.Clear;
End; { FindAllDigitalHats }

Procedure FindAllDigitalAxes;
Var
  I,J,K : Integer;
  Ch    : Char;
  St    : String;
  Ok    : Boolean;
  Ax    : TDigitalPacket;
  No    : TDigitalPacket;
  Up    : TDigitalPacket;
  Dn    : TDigitalPacket;
  Lf    : TDigitalPacket;
  Rt    : TDigitalPacket;
  U1    : TDigitalPacket;
  D1    : TDigitalPacket;
  L1    : TDigitalPacket;
  R1    : TDigitalPacket;
  P     : TDigitalPacket;

Begin
  StayPopup4(' Establish all digital axis functions ',' Step 3a ',
     '',
     'How many digital direction controls do you have?',
     '(DO NOT include hat controls)',
     '');
  Repeat
    St := _BufLen(15,4,'',7,0,1,2);
    Val(St,NumAxes,I);
  Until (NumAxes >= 0) And (NumAxes <= 9) And (I = 0);
  Dispose(_Win,Done);
  If NumAxes > 0 Then
  Begin
    For I := 1 To NumAxes Do
    Begin
      Repeat
        StayPopup12(' Establish all digital axis functions ',' Step 3b ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           'Slowly do the following:',
           '- Move DIGITAL direction controller ' + IntToStr(I) + ' to all extremes',
           '',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);

        { Isolate all bits for this control }

        Ax.Copy(DiffPacket);
        Packet.Copy(AnalogPacket);
        Packet._Not;
        Ax._And(Packet);
        Packet.Copy(HatPacket);
        Packet._Not;
        Ax._And(Packet);

{        Screen.FastWrite(1,MaxY - 8,7,Ax.AsString);}

        { Now get the base state (control not being pressed) }

        StayPopup12(' Establish all digital axis functions ',' Step 3c ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           '- Release DIGITAL direction controller ' + IntToStr(I),
           '',
           '',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);
        No.Copy(Packet);
        No._And(Ax);

{        Screen.FastWrite(1,MaxY - 7,7,No.AsString);}

        { Now figure out which bits correspond to the movement axes }

        StayPopup12(' Establish all digital axis functions ',' Step 3d ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           '- Hold DIGITAL direction controller ' + IntToStr(I) + ' UP',
           '',
           'MAKE SURE NOT TO HOLD IT IN A DIAGONAL DIRECTION',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);
        Up.Copy(Packet);
        Up._And(Ax);

{        Screen.FastWrite(1,MaxY - 6,7,Up.AsString);}

        StayPopup12(' Establish all digital axis functions ',' Step 3e ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           '- Hold DIGITAL direction controller ' + IntToStr(I) + ' DOWN',
           '',
           'MAKE SURE NOT TO HOLD IT IN A DIAGONAL DIRECTION',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);
        Dn.Copy(Packet);
        Dn._And(Ax);

{        Screen.FastWrite(1,MaxY - 5,7,Dn.AsString);}

        StayPopup12(' Establish all digital axis functions ',' Step 3f ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           '- Hold DIGITAL direction controller ' + IntToStr(I) + ' LEFT',
           '',
           'MAKE SURE NOT TO HOLD IT IN A DIAGONAL DIRECTION',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);
        Lf.Copy(Packet);
        Lf._And(Ax);

{        Screen.FastWrite(1,MaxY - 4,7,Lf.AsString);}

        StayPopup12(' Establish all digital axis functions ',' Step 3g ',
           '',
           'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
           'OTHER CONTROLS',
           '',
           '- Hold DIGITAL direction controller ' + IntToStr(I) + ' RIGHT',
           '',
           'MAKE SURE NOT TO HOLD IT IN A DIAGONAL DIRECTION',
           '',
           '',
           '',
           '',
           'When ready press a key (hit Esc to exit)');
        GatherAll;
        Dispose(_Win,Done);
        Rt.Copy(Packet);
        Rt._And(Ax);

{        Screen.FastWrite(1,MaxY - 3,7,Rt.AsString);}

        { Figure out what bit corresponds to what control, stripping out }
        { parity and "glitch" bits                                       }

        U1.Copy(Up);
        U1._Xor(No);

        D1.Copy(Dn);
        D1._Xor(No);

        R1.Copy(Rt);
        R1._Xor(No);

        L1.Copy(Lf);
        L1._Xor(No);

        { Make sure the readings are valid }

        P.Clear;
        For J := 0 To PacketSize - 1 Do
        Begin
          If U1.Bits[J] <> 0 Then Inc(P.Bits[J]);
          If D1.Bits[J] <> 0 Then Inc(P.Bits[J]);
          If L1.Bits[J] <> 0 Then Inc(P.Bits[J]);
          If R1.Bits[J] <> 0 Then Inc(P.Bits[J]);
        End; { For J }

        { There should be at least four "unique" bits, i.e. where the  }
        { corresponding bit in P is 1.  If the number is less than 4,  }
        { this means that, for example, up and right were both pressed }
        { instead of just up.                                          }

        K := 0;
        For J := 0 To PacketSize - 1 Do If P.Bits[J] = 1 Then Inc(K);
        If K < 4 Then
        Begin
          StayPopup4(' ERROR ','',
           'LEARN was unable to differentiate the four directions.',
           '',
           '                  Try again? (Y/N)',
           '');
          Repeat
            Ch := UpCase(ReadKey);
          Until Ch In ['N','Y'];
          Dispose(_Win,Done);
          Ok := (Ch = 'N');
        End
        Else Ok := True;
      Until Ok;

      P.Copy(U1);
      P._Xor(D1);
      P._Xor(R1);
      P._Xor(L1);

      U1._And(P);
      D1._And(P);
      R1._And(P);
      L1._And(P);

      PacketNum.SetDef(Chr(I - 1 + Ord('0')),P);
      PacketBit.SetDef('0',L1);
      PacketBit.SetDef('1',R1);
      PacketBit.SetDef('2',U1);
      PacketBit.SetDef('3',D1);
      AxisPacket.Copy(Ax);
      PacketDef.SetDef('X',AxisPacket);

      { Remove parity/glitch bits }

      P._Not;
      Ax._And(P);
      PacketDef.SetDef('?',Ax);
      PacketNum.SetDef(#0,Ax);
      PacketFlp.SetDef(#0,Ax);
      PacketBit.SetDef(#0,Ax);

      StayPopup12(' Establish all digital axis functions ',' Step 3h ',
         '',
         'DO NOT PRESS ANY JOYSTICK BUTTONS OR MANIPULATE ANY',
         'OTHER CONTROLS',
         '',
         '- Release DIGITAL direction controller ' + IntToStr(I),
         '',
         '',
         '',
         '',
         '',
         '',
         'When ready press a key (hit Esc to exit)');
      GatherAll;
      Dispose(_Win,Done);

    End; { For I }
  End
  Else DiffPacket.Clear;
End; { FindAllDigitalAxes }

Procedure FindAllButtons;
Begin
  StayPopup12(' Establish all button functions ',' Step 4 ',
     '',
     'Slowly do the following:',
     '- Press and release all joystick buttons',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     '',
     'When finished press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
End; { FindAllButtons }

Procedure FindAllThrottles;
Var
  I  : Integer;
  Ok : Boolean;
  Ch : Char;
  St : String;

Begin
  If HasThrottle Then
  Begin
    StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5 ',
       'How many throttles do you have?',
       '(include all analog flippers)',
       '(DO NOT include handle twist)',
       '');
    Repeat
      St := _BufLen(15,4,'',7,0,1,2);
      Val(St,NumThrottles,I);
    Until (NumThrottles >= 0) And (NumThrottles <= 9) And (I = 0);
    Dispose(_Win,Done);
    If NumThrottles = 0 Then
    Begin
      HasThrottle := False;
      PacketDef.SetDef('A',AnalogPacket);
    End
    Else
    Begin
      For I := 1 To NumThrottles Do
      Begin
        Repeat
          { Test with throttle/flipper at one extreme }

          StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5a ',
           '',
           'Move/hold throttle/flipper ' + IntToStr(I) + ' to one extreme',
           'and hit a key (hit Esc to exit)',
           '');
          GatherAll;
          Dispose(_Win,Done);
          StayPopup12(' Isolate throttle and analog flipper functions ',' Step 5b ',
           '',
           'With throttle/flipper at extreme position,',
           'rotate all analog joysticks around the center',
           'position, twist analog handle(s) around the',
           'center position, and wiggle all other throttle/',
           'flippers around their center positions',
           '',
           '',
           '',
           '',
           '',
           'When finished press a key (hit Esc to exit)');
          GatherAll;
          Dispose(_Win,Done);
          WorkPacket1.Copy(DiffPacket);
          WorkPacket1._And(AnalogPacket);

          { Test with throttle/flipper at the other extreme }

          StayPopup4(' Isolate throttle and analog flipper functions ',' Step 5c ',
           '',
           'Move/hold throttle/flipper ' + IntToStr(I) + ' to the other extreme',
           'and hit a key (hit Esc to exit)',
           '');
          GatherAll;
          Dispose(_Win,Done);
          StayPopup12(' Isolate throttle and analog flipper functions ',' Step 5d ',
           '',
           'With throttle/flipper at extreme position,',
           'rotate all analog joysticks around the center',
           'position, twist analog handle(s) around the',
           'center position, and wiggle all other throttle/',
           'flippers around their center positions',
           '',
           '',
           '',
           '',
           '',
           'When finished press a key (hit Esc to exit)');
          GatherAll;
          Dispose(_Win,Done);
          WorkPacket2.Copy(DiffPacket);
          WorkPacket2._And(AnalogPacket);

          WorkPacket.Copy(WorkPacket1);
          WorkPacket._And(WorkPacket2);

          If (Not WorkPacket1.Equal(WorkPacket2)) Or (WorkPacket1.Count = 0) Then
          Begin
            StayPopup4(' ERROR ','',
             'LEARN was unable to differentiate the throttle/flipper',
             'from the rest of the joystick.',
             '',
             '                  Try again? (Y/N)');
            Repeat
              Ch := UpCase(ReadKey);
            Until Ch In ['N','Y'];
            Dispose(_Win,Done);
            Ok := (Ch = 'N');
          End
          Else
          Begin
            Ok := True;
            WorkPacket._Not;
            ThrottlePacket.Copy(AnalogPacket);
            ThrottlePacket._And(WorkPacket);
            AnalogPacket._And(WorkPacket1);
            PacketDef.SetDef('T',ThrottlePacket);
            PacketDef.SetDef('A',AnalogPacket);
            PacketNum.SetDef(ToChar(I - 1),ThrottlePacket);
          End;
        Until Ok;
      End; { For I }
    End;
  End;
End; { FindAllThrottles }

Procedure FindLevels;
Var
  I,J,K : Integer;
  P0,P1 : TDigitalPacket;

Begin
  StayPopup12(' Determine base levels ',' Step 6 ',
       '',
   'Let go of all joystick buttons,',
   'move all THROTTLES to their minimums,',
   'twist ANALOG handle(s) to minimums,',
   'and hold all other ANALOG controls to their',
   'minimums (move joystick/controller to',
   'UPPER LEFT).',
   '',
   'Leave all DIGITAL controls CENTERED.',
   '',
   '',
   'When ready press a key (hit Esc to exit)');
  GatherAll;
  Dispose(_Win,Done);
  P0.Clear;
  P1.Clear;
  For I := 0 To PacketSize - 1 Do
  Begin
    Case Chr(PacketDef.Bits[I]) Of
      'B': PacketFlp.Bits[I] := Packet.Bits[I];
  'A','T','X','H':
           Begin
             For J := 0 To PacketSize - 1 Do
             Begin
               If (PacketDef.Bits[J] = PacketDef.Bits[I]) And
                  (PacketNum.Bits[J] = PacketNum.Bits[I]) Then
               Begin
                 If Packet.Bits[I] <> 0
                  Then Inc(P1.Bits[J])
                  Else Inc(P0.Bits[J]);
               End;
             End; { For J }
           End;
    End; { Case }
  End; { For I }
  For I := 0 To PacketSize - 1 Do
  Begin
    If Chr(PacketDef.Bits[I]) In ['A','H','T','X'] Then
    Begin
      If P1.Bits[I] > P0.Bits[I]
       Then PacketFlp.Bits[I] := 1
       Else PacketFlp.Bits[I] := 0;
    End;
  End; { For I }
End; { FindLevels }

Procedure FindParity;
Var
  I     : Integer;
  Found : Boolean;

Begin
  I := PacketSize - 1;
  Found := False;
  ReadPacket(Packet);
  While (I >= 0) And Not Found Do
  Begin
    If Chr(PacketDef.Bits[I]) In ['A','X','?'] Then
    Begin
      If I = PacketSize - 1 Then
      Begin
        If Chr(PacketDef.Bits[I - 1]) <> Chr(PacketDef.Bits[I]) Then Found := True Else Dec(I);
      End
      Else
      If I = 0 Then
      Begin
        If Chr(PacketDef.Bits[I + 1]) <> Chr(PacketDef.Bits[I]) Then Found := True Else Dec(I);
      End
      Else
      Begin
        If (Chr(PacketDef.Bits[I - 1]) <> Chr(PacketDef.Bits[I])) And
           (Chr(PacketDef.Bits[I + 1]) <> Chr(PacketDef.Bits[I])) Then Found := True Else Dec(I);
      End;
    End
    Else Dec(I);
  End; { While }
  If (OddCount / MasterCount < 0.1) And Found Then  { Even parity }
  Begin
    PacketDef.Bits[I]    := Ord('P');
    PacketFlp.Bits[I]    := 1;
    PacketBit.Bits[I]    := 0;
    PacketNum.Bits[I]    := 0;
    AnalogPacket.Bits[I] := 0;
    StayPopup4(' Parity bit detection ',' Step 7 ',
     'A possible parity bit was detected.',
     '',
     '',
     'Press any key');
    ReadKey;
    Dispose(_Win,Done);
  End
  Else
  If (OddCount / MasterCount > 0.9) And Found Then  { Odd parity }
  Begin
    PacketDef.Bits[I]    := Ord('P');
    PacketFlp.Bits[I]    := 0;
    PacketBit.Bits[I]    := 0;
    PacketNum.Bits[I]    := 0;
    AnalogPacket.Bits[I] := 0;
    StayPopup4(' Parity bit detection ',' Step 7 ',
     'A possible parity bit was detected.',
     '',
     '',
     'Press any key');
    ReadKey;
    Dispose(_Win,Done);
  End
  Else
  Begin
    StayPopup4(' Parity bit detection ',' Step 7 ',
     'No possible parity bits were detected.',
     '',
     '',
     'Press any key');
    ReadKey;
    Dispose(_Win,Done);
  End;
End; { FindParity }

Procedure IsolateMainAnalogAxis;
Var
  Ok  : Boolean;
  Ch  : Char;
  I,J : Integer;

Begin
  If HasAnalog Then
  Begin
    StayPopup4(' Isolate x/y analog axis ',' Step 8 ',
     'Does your controller support ANALOG movement? (Y/N)',
     '(not including THROTTLES)',
     '',
     'Hit esc to exit');
    Repeat
      Ch := UpCase(ReadKey);
    Until Ch In [#27,'N','Y'];
    Dispose(_Win,Done);
    If Ch = #27 Then Halt;
    If Ch = 'Y' Then
    Begin

      { Isolate X axis }

      StayPopup4(' Isolate X axis ',' Step 8a ',
       'Hold joystick/controller all the way to the LEFT,',
       'but keep all other axes CENTERED.',
       '',
       'Press a key when ready or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      StayPopup4(' Isolate X axis ',' Step 8b ',
       'Holding joystick/controller all the way to the LEFT,',
       'wiggle/twist all other axes slightly',
       '',
       'Press a key when finished or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket1.Copy(DiffPacket);
      WorkPacket1._And(AnalogPacket);

      StayPopup4(' Isolate X axis ',' Step 8c ',
       'Hold joystick/controller all the way to the RIGHT,',
       'but keep all other axes CENTERED.',
       '',
       'Press a key when ready or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      StayPopup4(' Isolate X axis ',' Step 8d ',
       'Holding joystick/controller all the way to the RIGHT,',
       'wiggle/twist all other axes slightly',
       '',
       'Press a key when finished or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket2.Copy(DiffPacket);
      WorkPacket2._And(AnalogPacket);

      WorkPacket3.Copy(WorkPacket1);
      WorkPacket3._And(WorkPacket2);

      { Isolate Y axis }

      StayPopup4(' Isolate Y axis ',' Step 8e ',
       'Hold joystick/controller all the way to the TOP,',
       'but keep all other axes CENTERED.',
       '',
       'Press a key when ready or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      StayPopup4(' Isolate Y axis ',' Step 8f ',
       'Holding joystick/controller all the way to the TOP,',
       'wiggle/twist all other axes slightly',
       '',
       'Press a key when finished or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket1.Copy(DiffPacket);
      WorkPacket1._And(AnalogPacket);

      StayPopup4(' Isolate Y axis ',' Step 8g ',
       'Hold joystick/controller all the way to the BOTTOM,',
       'but keep all other axes CENTERED.',
       '',
       'Press a key when ready or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      StayPopup4(' Isolate Y axis ',' Step 8h ',
       'Holding joystick/controller all the way to the BOTTOM,',
       'wiggle/twist all other axes slightly',
       '',
       'Press a key when finished or hit Esc to exit');
      GatherAll;
      Dispose(_Win,Done);
      WorkPacket2.Copy(DiffPacket);
      WorkPacket2._And(AnalogPacket);

      WorkPacket4.Copy(WorkPacket1);
      WorkPacket4._And(WorkPacket2);

      WorkPacket.Copy(WorkPacket4);
      WorkPacket._Not;
      WorkPacket._And(AnalogPacket);
      PacketNum.SetDef(#1,WorkPacket);

      WorkPacket.Copy(WorkPacket3);
      WorkPacket._And(WorkPacket4);
      If WorkPacket.Count > 0 Then
      Begin
        StayPopup4(' Isolate joystick x/y movement ',' Step 8i ',
         'Aside from x/y analog motion, is there only one other',
         'analog axis? (e.g. handle twist)',
         '',
         'Hit Y or N');
        Repeat
          Ch := UpCase(ReadKey);
        Until Ch In ['N','Y'];
        Dispose(_Win,Done);
        If Ch = 'Y' Then
        Begin

          { Find the maximum throttle number }

          J := -1;
          For I := 0 To PacketSize - 1 Do
          Begin
            If (Chr(PacketDef.Bits[I]) = 'T') And
               (PacketNum.Bits[I] > J) Then J := PacketNum.Bits[I];
          End; { For I }

          { Change the remaining analog axis to another throttle }

          StayPopup4(' Isolate joystick x/y movement ',' Step 8j ',
           'Since the emulator requires that analog axes come in',
           'pairs, the remaining axis will be changed to a throttle.',
           '',
           'Hit any key');
          ReadKey;
          Dispose(_Win,Done);
          ThrottlePacket._Or(WorkPacket);
          AnalogPacket._Xor(WorkPacket);
          PacketNum.SetDef(Chr(J + 1),WorkPacket);
          PacketDef.SetDef('T',WorkPacket);
        End
        Else PacketNum.SetDef('2',WorkPacket);
      End;
    End
    Else HasAnalog := False;
  End;
End; { IsolateMainAnalogAxis }

Procedure Display;
Begin
  Screen.TextColor(LightGray);
  Screen.TextBackground(Blue);
  Screen.GotoXY(1,1);
  Screen.Write('Packet size: ' + IntToStr(PacketSize));
  Screen.GotoXY(1,3);
  Screen.WriteLn('Def:' + PacketDef.AsString + '    ');
  Screen.WriteLn('Num:' + PacketNum.AsString + '    ');
  Screen.WriteLn('Flp:' + PacketFlp.AsString + '    ');
  Screen.WriteLn('Bit:' + PacketBit.AsString + '    ');
End; { Display }

Procedure SaveToDisk;
Var
  F     : PINIFile;
  I     : Integer;
  Found : Boolean;
  St    : String;
  A,T,H : Array[0..31] Of Integer;

Begin
  FillChar(A,SizeOf(A),#0);
  FillChar(T,SizeOf(T),#0);
  FillChar(H,SizeOf(H),#0);
  For I := 0 To PacketSize - 1 Do
  Begin
    Case Chr(PacketDef.Bits[I]) Of
      'A': Begin
             PacketBit.Bits[I] := A[PacketNum.Bits[I]] + Ord('0');
             Inc(A[PacketNum.Bits[I]]);
           End;
      'T': Begin
             PacketBit.Bits[I] := T[PacketNum.Bits[I]] + Ord('0');
             Inc(T[PacketNum.Bits[I]]);
           End;
      'H': Begin
             PacketBit.Bits[I] := H[PacketNum.Bits[I]] + Ord('0');
             Inc(H[PacketNum.Bits[I]]);
           End;
    End; { Case }
  End; { For I }

  { Scan INI file }

  F     := New(PINIFile,Init(ConfigFile));
  Found := False;
  I     := 1;
  Repeat
    St := F^.ReadString('SIDEWINDER','DIG' + IntToStr(I) + 'BIT','');
    If Length(St) = PacketSize Then Found := True Else Inc(I);
  Until (St = '') Or Found;
  If Not Found Then
  Begin
    Dec(I);
    StayPopup12(' Save to disk ','',
       '',
       'Your controller packet does not appear to be in',
       'PCAE.INI.  LEARN will add it to the packet list.',
       'What is the name of your controller?',
       ' e.g. SideWinder GamePad',
       '',
       '',
       '',
       '',
       '',
       '',
       '');
    Repeat
      St := _BufLen(2,7,'',7,0,80,40);
    Until St <> '';
    Dispose(_Win,Done);
    F^.WriteString('SIDEWINDER','DIG' + IntToStr(I) + 'AAA',St);
  End;
  F^.WriteString('SIDEWINDER','DIG' + IntToStr(I) + 'DEF',PacketDef.AsString);
  F^.WriteString('SIDEWINDER','DIG' + IntToStr(I) + 'NUM',PacketNum.AsString);
  F^.WriteString('SIDEWINDER','DIG' + IntToStr(I) + 'FLP',PacketFlp.AsString);
  F^.WriteString('SIDEWINDER','DIG' + IntToStr(I) + 'BIT',PacketBit.AsString);
  Dispose(F,Done);
End; { SaveToDisk }

Procedure Introduction;
Begin
  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   '',
   'This program guides you through a series',
   'of steps in an attempt to determine how',
   'to interface with your SideWinder',
   'controller.  SideWinder controllers send',
   'information to your computer using bit',
   'packets.  Throughout the steps in this',
   'program, the packet being sent to your',
   'computer can be seen at the bottom of',
   'your screen.',
   '',
   '');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   '',
   'As you progress through the steps in this',
   'program, you will see three packets at the',
   'top of your screen.  These show what LEARN',
   'currently knows about the packet structure.',
   'As you complete the steps, the program will',
   'occasionally fill in more information as it',
   'learns more about your controller''s packet',
   'structure.',
   '',
   '',
   '');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   'Before you start the first learning step, there',
   'are some important terms you need to know:',
   '',
   'ANALOG refers to controls with variable movement,',
   'such as an analog joystick.  It also includes',
   'joystick handle twist, BUT NOT THROTTLES.',
   '',
   'THROTTLE refers to a control that has variable',
   'movement in only one direction.  This excludes',
   'handle twist, however, since handle twist is',
   'physically hard to isolate (handle twist is',
   'handled separately).');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   'A standard SideWinder GamePad, for example,',
   'has neither ANALOG nor THROTTLE functions.',
   '',
   'DIGITAL controls are controls that do not have',
   'variable movement.  Directional pads and hats',
   'that have only up/down/left/right movement',
   '(but not variable up/down, etc.) are examples.',
   '',
   'Digital AXES refer to directional pads.',
   '',
   'Digital HATS refer to hat controls, typically on',
   'the end of a joystick.  Hats and axes are DIFFERENT.');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   '',
   'BUTTONS are self-explanatory.  Press-and-release,',
   'they can either be momentary switches or push-on/',
   'push-off.',
   '',
   '',
   '',
   '',
   '',
   '',
   '',
   '');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

  StayPopup12(' Introduction ',' Hit a key to continue, or <Esc> to quit ',
   '',
   'That''s it for the introduction.  Hit a key',
   'to auto-detect the packet size and start the',
   'learning tests.  Auto-detection can take up',
   'to a minute to complete.',
   '',
   '',
   '',
   '',
   '',
   '',
   '');
  If ReadKey = #27 Then Halt;
  Dispose(_Win,Done);

End; { Introduction }

Begin
  MasterCount := 0;
  OddCount    := 0;
  Screen.TextColor(LightGray);
  Screen.TextBackground(Blue);
  Screen.ClrScr;

  Introduction;

  StayPopup(' SideWinder Learn Program ','','Detecting packet size...');

  GetMaxJoyCount;
  GetPacketSize;
  Dispose(_Win,Done);

  PacketDef.SetAllDef('?');
  PacketNum.Clear;
  PacketFlp.Clear;
  PacketBit.Clear;

  HasAnalog   := True;
  HasThrottle := True;

  OnePacket.Clear;
  ZeroPacket.Clear;
  OnePacket._Not;
  AnalogPacket.Clear;
  HatPacket.Clear;
  AxisPacket.Clear;
  BtnPacket.Clear;
  ThrottlePacket.Clear;
  Display;

  FindAll;                         { Locate all functions }
  Display;

  FindAllAnalog;                   { Locate all analog functions }
  AnalogPacket.Copy(DiffPacket);
  PacketDef.SetDef('a',AnalogPacket);
  Display;

  FindAllDigitalHats;              { Isolate all digital hat functions }
  HatPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  HatPacket._And(Packet);
  PacketDef.SetDef('H',HatPacket);
  Display;

  FindAllDigitalAxes;              { Isolate all digital axis functions }
(*
  AxisPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  AxisPacket._And(Packet);
  Packet.Copy(HatPacket);
  Packet._Not;
  AxisPacket._And(Packet);
  PacketDef.SetDef('X',AxisPacket);
*)
  Display;

  FindAllButtons;                  { Isolate all button functions }
  BtnPacket.Copy(DiffPacket);
  Packet.Copy(AnalogPacket);
  Packet._Not;
  BtnPacket._And(Packet);
  Packet.Copy(HatPacket);
  Packet._Not;
  BtnPacket._And(Packet);
  Packet.Copy(AxisPacket);
  Packet._Not;
  BtnPacket._And(Packet);
  PacketDef.SetDef('B',BtnPacket);
  J := 0;
  For I := 0 To PacketSize - 1 Do
  Begin
    If Chr(PacketDef.Bits[I]) = 'B' Then
    Begin
      PacketNum.Bits[I] := Ord(ToChar(J));
      Inc(J);
    End;
  End; { For I }
  Display;

  FindAllThrottles;                { Isolate all throttle functions }
  Display;

  FindLevels;                      { Determine flip information }
  Display;

  FindParity;                      { Look for a parity bit }
  Display;

  IsolateMainAnalogAxis;           { Isolate main x/y axis }
  Display;

  { Include "always one" and "always zero" information }

  ZeroPacket._Not;
  PacketDef.SetDef('0',ZeroPacket);
  PacketDef.SetDef('1',OnePacket);
  Display;

  { Write packet definition to disk }

  SaveToDisk;
  Display;

  StayPopup12(' Saving configuration ',' Final step ',
     '',
     '',
     'Wrote configuration to PCAE.INI',
     '',
     '',
     'Hit a key to exit',
     '',
     '',
     '',
     '',
     '',
     '');
  ReadKey;
  Dispose(_Win,Done);

(*
  Assign(F,ConfigFile);
  ReWrite(F);
  WriteLn(F,'; LEARN.INI - Detected Microsoft packet information');
  WriteLn(F);
  WriteLn(F,'; Legend: (def)');
  WriteLn(F,';         B - button');
  WriteLn(F,';         X - digital axis');
  WriteLn(F,';         H - digital hat');
  WriteLn(F,';         T - analog throttle/flipper');
  WriteLn(F,';         A - analog axis');
  WriteLn(F,';         0 - always 0');
  WriteLn(F,';         1 - always 1');
  WriteLn(F);
  WriteLn(F,'; Notes');
  WriteLn(F,';         1. Some digital hats are really digital axes and vice versa.');
  WriteLn(F);
  WriteLn(F,'[CONFIG]');
  WriteLn(F,'DEF=' + PacketDef.AsString);
  WriteLn(F,'NUM=' + PacketNum.AsString);
  WriteLn(F,'FLP=' + PacketFlp.AsString);
  Close(F);

  StayPopup12(' Saving configuration ',' Final step ',
     '',
     '',
     'Writing configuration to LEARN.INI',
     '',
     '',
     'Hit a key to exit',
     '',
     '',
     '',
     '',
     '',
     '');
  ReadKey;
  Dispose(_Win,Done);
*)
End.
